/*	Public domain	*/

#ifdef HAVE_PERL
#include <EXTERN.h>
#include <perl.h>
#endif

#include <sys/types.h>
#include <sys/file.h>
#include <stdlib.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>

#include <config/have_setproctitle.h>
#include <config/have_flock.h>
#include <config/have_open_exlock.h>

#include "queue.h"
#include "table.h"
#include "fgetln.h"
#include "strlcpy.h"
#include "strlcat.h"

#include "sockunion.h"
#include "maillist.h"
#include "message.h"
#include "sa.h"
#include "smtp.h"
#include "qmgr.h"
#include "local.h"
#include "policy.h"
#include "control.h"
#include "spamcheck.h"

#define Malloc(len) SF_Malloc(len)
#define Fatal SF_Fatal

#ifdef DEBUG
#define Debug SF_Debug
#else
#define Debug(arg...) ((void)0)
#endif

#ifdef HAVE_SETPROCTITLE
#define Setproctitle setproctitle
#else
#define Setproctitle(arg...) ((void)0)
#endif

#if defined(__OpenBSD__) || defined(__NetBSD__) || defined(__FreeBSD__)
typedef socklen_t my_socklen_t;
#else
typedef int my_socklen_t;
#endif

typedef enum {
	SF_NONE,
	SF_AND,
	SF_OR
} SF_LogicOp;

extern int sfPollInterval;
extern int sfPolicyServer;
extern char *sfHostSMTP, *sfPortSMTP;
extern char *sfReinHost, *sfReinPort;
extern FILE *sfLog;

void	 SF_Debug(const char *, ...);
void	*SF_Malloc(size_t);
void	 SF_Fatal(const char *, ...);
void	 SF_SetError(const char *, ...);
char	*SF_GetError(void);
void	 SF_EnterServerProc(const char *);
void	 SF_ExitServerProc(int);

#ifdef HAVE_FLOCK
#define LockFile(fd) flock((fd),LOCK_EX)
#define UnlockFile(fd) flock((fd),LOCK_UN)
#else
#define LockFile(fd) (void)(0)
#define UnlockFile(fd) (void)(0)
#endif
